# dummy key will be used to avoid servers root passwords being mailed
# will use https://authkeys.io to setup real authorization
resource "hcloud_ssh_key" "dummy-key" {
  name       = "dummy-key"
  public_key = "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIDG6KCXcL6bgJKD/ZbzLDeZms6TJwUz7K0yf+KCvfjxV dummy-key"
}

variable "theo_token" {}

resource "hcloud_server" "fcub01" {
  name        = "fcub01"
  image       = "ubuntu-20.04"
  server_type = "cpx31"
  ssh_keys    = [hcloud_ssh_key.dummy-key.id]
  user_data   = templatefile("templates/cloud-init.yml.tpl", { theo_token = var.theo_token })
  lifecycle {
    ignore_changes = [user_data]
  }
}

data "linode_domain" "fluidware-it" {
  domain = "fluidware.it"
}

resource "linode_domain_record" "fcub-ipv4" {
  domain_id   = data.linode_domain.fluidware-it.id
  name        = "fcub"
  record_type = "A"
  target      = hcloud_server.fcub01.ipv4_address
}

resource "linode_domain_record" "fcub-ipv6" {
  domain_id   = data.linode_domain.fluidware-it.id
  name        = "fcub"
  record_type = "AAAA"
  target      = hcloud_server.fcub01.ipv6_address
}

resource "linode_domain_record" "grafana_fcub" {
  domain_id   = data.linode_domain.fluidware-it.id
  name        = "grafana.fcub"
  record_type = "CNAME"
  target      = "fcub.fluidware.it"
}
